'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Immutable = require('immutable');
var assert = require('./assert');

var _require = require('./transaction'),
    Transaction = _require.Transaction;

var createObjectManagerConstructor = function createObjectManagerConstructor(QuerySetConstructor) {
  return function (_QuerySetConstructor) {
    (0, _inherits3.default)(_class, _QuerySetConstructor);

    function _class(_ref) {
      var model = _ref.model,
          emitter = _ref.emitter,
          setup = _ref.setup,
          values = _ref.values,
          _ref$transaction = _ref.transaction,
          transaction = _ref$transaction === undefined ? null : _ref$transaction;
      (0, _classCallCheck3.default)(this, _class);

      var _this = (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, { QuerySetConstructor: QuerySetConstructor }));

      _this.model = model;
      _this.values = values;
      _this.emitter = emitter;
      _this.transaction = transaction;
      _this.setup = setup;
      return _this;
    }

    (0, _createClass3.default)(_class, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, values;

        return _regenerator2.default.wrap(function entries$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 3;
                _iterator = this.values.entries()[Symbol.iterator]();

              case 5:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 12;
                  break;
                }

                _step$value = (0, _slicedToArray3.default)(_step.value, 2), values = _step$value[1];
                _context.next = 9;
                return this.build(values);

              case 9:
                _iteratorNormalCompletion = true;
                _context.next = 5;
                break;

              case 12:
                _context.next = 18;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context['catch'](3);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 18:
                _context.prev = 18;
                _context.prev = 19;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 21:
                _context.prev = 21;

                if (!_didIteratorError) {
                  _context.next = 24;
                  break;
                }

                throw _iteratorError;

              case 24:
                return _context.finish(21);

              case 25:
                return _context.finish(18);

              case 26:
              case 'end':
                return _context.stop();
            }
          }
        }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
      })
    }, {
      key: 'createTransaction',
      value: function createTransaction() {
        assert.hasNoTransaction(this);
        this.transaction = new Transaction({ values: this.values, setup: this.setup });

        return this.transaction;
      }
    }, {
      key: 'commitTransaction',
      value: function commitTransaction() {
        this.values = this.transaction.values;
        this.transaction = null;
      }
    }, {
      key: 'abortTransaction',
      value: function abortTransaction() {
        this.transaction = null;
      }
    }, {
      key: 'build',
      value: function build() {
        var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Immutable.Map();

        var EntryConstructor = this.setup.get('EntryConstructor');
        return new EntryConstructor({ values: values, model: this.model, setup: this.setup });
      }
    }, {
      key: 'get',
      value: function get(expression) {
        return typeof expression === 'string' ? this.build(this.values.get(expression)) : (0, _get3.default)(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'get', this).call(this, expression);
      }
    }, {
      key: 'create',
      value: function create() {
        var rawValues = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        var entry = this.build();

        entry.save();
        entry.update(rawValues);

        return entry;
      }
    }, {
      key: 'getOrCreate',
      value: function getOrCreate(expression) {
        return this.get(expression) || this.create(expression);
      }
    }, {
      key: 'sync',
      value: function sync(values) {
        assert.hasTransaction(this);
        return this.transaction.sync(values);
      }
    }, {
      key: 'unsync',
      value: function unsync(values) {
        assert.hasTransaction(this);
        return this.transaction.unsync(values);
      }
    }]);
    return _class;
  }(QuerySetConstructor);
};

module.exports = {
  createObjectManagerConstructor: createObjectManagerConstructor
};
