'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var sortBy = require('sort-by');

var REVERSED = 1;

/*
 * Filter
 */

var createFilterPredicate = function createFilterPredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] === expression[key];
    });
  };
};

var getFilterPredicate = function getFilterPredicate(expression) {
  return typeof expression === 'function' ? expression : createFilterPredicate(expression);
};

/*
 * Exclude
 */

var createExcludePredicate = function createExcludePredicate(expression) {
  return function (entry) {
    return Object.keys(expression).every(function (key) {
      return entry[key] !== expression[key];
    });
  };
};

var getExcludePredicate = function getExcludePredicate(expression) {
  return typeof expression === 'function' ? expression : createExcludePredicate(expression);
};

/*
 * Mixin
 */

var withSortedEntries = function withSortedEntries(_ref) {
  var Base = _ref.Base,
      sortComparator = _ref.sortComparator;
  return function (_Base) {
    (0, _inherits3.default)(_class, _Base);

    function _class() {
      (0, _classCallCheck3.default)(this, _class);
      return (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    (0, _createClass3.default)(_class, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, entry;

        return _regenerator2.default.wrap(function entries$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 3;
                _iterator = this.parent.toArray().sort(sortComparator).entries()[Symbol.iterator]();

              case 5:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 12;
                  break;
                }

                _step$value = (0, _slicedToArray3.default)(_step.value, 2), entry = _step$value[1];
                _context.next = 9;
                return entry;

              case 9:
                _iteratorNormalCompletion = true;
                _context.next = 5;
                break;

              case 12:
                _context.next = 18;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context['catch'](3);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 18:
                _context.prev = 18;
                _context.prev = 19;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 21:
                _context.prev = 21;

                if (!_didIteratorError) {
                  _context.next = 24;
                  break;
                }

                throw _iteratorError;

              case 24:
                return _context.finish(21);

              case 25:
                return _context.finish(18);

              case 26:
              case 'end':
                return _context.stop();
            }
          }
        }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
      })
    }]);
    return _class;
  }(Base);
};

var withFilteredEntries = function withFilteredEntries(_ref2) {
  var Base = _ref2.Base,
      predicate = _ref2.predicate;
  return function (_Base2) {
    (0, _inherits3.default)(_class2, _Base2);

    function _class2() {
      (0, _classCallCheck3.default)(this, _class2);
      return (0, _possibleConstructorReturn3.default)(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).apply(this, arguments));
    }

    (0, _createClass3.default)(_class2, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, entry;

        return _regenerator2.default.wrap(function entries$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context2.prev = 3;
                _iterator2 = this.parent.entries()[Symbol.iterator]();

              case 5:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context2.next = 13;
                  break;
                }

                entry = _step2.value;

                if (!predicate(entry)) {
                  _context2.next = 10;
                  break;
                }

                _context2.next = 10;
                return entry;

              case 10:
                _iteratorNormalCompletion2 = true;
                _context2.next = 5;
                break;

              case 13:
                _context2.next = 19;
                break;

              case 15:
                _context2.prev = 15;
                _context2.t0 = _context2['catch'](3);
                _didIteratorError2 = true;
                _iteratorError2 = _context2.t0;

              case 19:
                _context2.prev = 19;
                _context2.prev = 20;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 22:
                _context2.prev = 22;

                if (!_didIteratorError2) {
                  _context2.next = 25;
                  break;
                }

                throw _iteratorError2;

              case 25:
                return _context2.finish(22);

              case 26:
                return _context2.finish(19);

              case 27:
              case 'end':
                return _context2.stop();
            }
          }
        }, entries, this, [[3, 15, 19, 27], [20,, 22, 26]]);
      })
    }]);
    return _class2;
  }(Base);
};

var withEmptyGenerator = function withEmptyGenerator(_ref3) {
  var Base = _ref3.Base;
  return function (_Base3) {
    (0, _inherits3.default)(_class3, _Base3);

    function _class3() {
      (0, _classCallCheck3.default)(this, _class3);
      return (0, _possibleConstructorReturn3.default)(this, (_class3.__proto__ || Object.getPrototypeOf(_class3)).apply(this, arguments));
    }

    (0, _createClass3.default)(_class3, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        return _regenerator2.default.wrap(function entries$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
              case 'end':
                return _context3.stop();
            }
          }
        }, entries, this);
      })
    }]);
    return _class3;
  }(Base);
};

var withQueries = function withQueries(QuerySetBase) {
  return function (_QuerySetBase) {
    (0, _inherits3.default)(_class4, _QuerySetBase);

    function _class4() {
      (0, _classCallCheck3.default)(this, _class4);
      return (0, _possibleConstructorReturn3.default)(this, (_class4.__proto__ || Object.getPrototypeOf(_class4)).apply(this, arguments));
    }

    (0, _createClass3.default)(_class4, [{
      key: 'filter',
      value: function filter(expression) {
        var Base = this.QuerySetConstructor;
        var predicate = getFilterPredicate(expression);
        var QuerySetConstructor = withFilteredEntries({ Base: Base, predicate: predicate });

        return this.clone({ QuerySetConstructor: QuerySetConstructor });
      }
    }, {
      key: 'exclude',
      value: function exclude(expression) {
        var Base = this.QuerySetConstructor;
        var predicate = getExcludePredicate(expression);
        var QuerySetConstructor = withFilteredEntries({ Base: Base, predicate: predicate });

        return this.clone({ QuerySetConstructor: QuerySetConstructor });
      }
    }, {
      key: 'sort',
      value: function sort(sortComparator) {
        var Base = this.QuerySetConstructor;
        var QuerySetConstructor = withSortedEntries({ Base: Base, sortComparator: sortComparator });

        return this.clone({ QuerySetConstructor: QuerySetConstructor });
      }
    }, {
      key: 'reverse',
      value: function reverse() {
        var Base = this.QuerySetConstructor;
        var sortComparator = function sortComparator() {
          return REVERSED;
        };
        var QuerySetConstructor = withSortedEntries({ Base: Base, sortComparator: sortComparator });

        return this.clone({ QuerySetConstructor: QuerySetConstructor });
      }
    }, {
      key: 'none',
      value: function none() {
        var Base = this.QuerySetConstructor;
        var QuerySetConstructor = withEmptyGenerator({ Base: Base });

        return this.clone({ QuerySetConstructor: QuerySetConstructor });
      }
    }, {
      key: 'orderBy',
      value: function orderBy() {
        var sortComparator = sortBy.apply(undefined, arguments);

        return this.sort(sortComparator);
      }
    }, {
      key: 'all',
      value: function all() {
        return this.clone({ QuerySetConstructor: this.QuerySetConstructor });
      }
    }]);
    return _class4;
  }(QuerySetBase);
};

module.exports = {
  withQueries: withQueries,
  getFilterPredicate: getFilterPredicate,
  getExcludePredicate: getExcludePredicate
};
