'use strict';

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./query'),
    withQueries = _require.withQueries;

var _require2 = require('./export'),
    withExporters = _require2.withExporters;

var QuerySetBase = function () {
  function QuerySetBase(_ref) {
    var QuerySetConstructor = _ref.QuerySetConstructor,
        _ref$parent = _ref.parent,
        parent = _ref$parent === undefined ? null : _ref$parent;
    (0, _classCallCheck3.default)(this, QuerySetBase);

    this.parent = parent;
    this.QuerySetConstructor = QuerySetConstructor;
  }

  (0, _createClass3.default)(QuerySetBase, [{
    key: 'entries',
    value: _regenerator2.default.mark(function entries() {
      var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, entry;

      return _regenerator2.default.wrap(function entries$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _iteratorNormalCompletion = true;
              _didIteratorError = false;
              _iteratorError = undefined;
              _context.prev = 3;
              _iterator = this.parent.entries()[Symbol.iterator]();

            case 5:
              if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                _context.next = 12;
                break;
              }

              entry = _step.value;
              _context.next = 9;
              return entry;

            case 9:
              _iteratorNormalCompletion = true;
              _context.next = 5;
              break;

            case 12:
              _context.next = 18;
              break;

            case 14:
              _context.prev = 14;
              _context.t0 = _context['catch'](3);
              _didIteratorError = true;
              _iteratorError = _context.t0;

            case 18:
              _context.prev = 18;
              _context.prev = 19;

              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }

            case 21:
              _context.prev = 21;

              if (!_didIteratorError) {
                _context.next = 24;
                break;
              }

              throw _iteratorError;

            case 24:
              return _context.finish(21);

            case 25:
              return _context.finish(18);

            case 26:
            case 'end':
              return _context.stop();
          }
        }
      }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
    })
  }, {
    key: 'update',
    value: function update(rawValues) {
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.entries()[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var entry = _step2.value;

          entry.update(rawValues);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }, {
    key: 'delete',
    value: function _delete() {
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = this.entries()[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var entry = _step3.value;

          entry.delete();
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
  }, {
    key: 'clone',
    value: function clone(_ref2) {
      var _ref2$QuerySetConstru = _ref2.QuerySetConstructor,
          QuerySetConstructor = _ref2$QuerySetConstru === undefined ? this.QuerySetConstructor : _ref2$QuerySetConstru;

      return new QuerySetConstructor({ parent: this, QuerySetConstructor: this.QuerySetConstructor });
    }
  }]);
  return QuerySetBase;
}();

var QuerySetWithQueries = withQueries(QuerySetBase);
var QuerySetWithExporters = withExporters(QuerySetWithQueries);

var QuerySet = function (_QuerySetWithExporter) {
  (0, _inherits3.default)(QuerySet, _QuerySetWithExporter);

  function QuerySet() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _classCallCheck3.default)(this, QuerySet);
    return (0, _possibleConstructorReturn3.default)(this, (QuerySet.__proto__ || Object.getPrototypeOf(QuerySet)).call(this, Object.assign({ QuerySetConstructor: QuerySet }, opts)));
  }

  return QuerySet;
}(QuerySetWithExporters);

module.exports = {
  QuerySet: QuerySet
};
