'use strict';

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _get2 = require('babel-runtime/helpers/get');

var _get3 = _interopRequireDefault(_get2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('./model'),
    createModel = _require.createModel,
    createEntryMixin = _require.createEntryMixin,
    createObjectManagerMixin = _require.createObjectManagerMixin;

var _require2 = require('./field'),
    withField = _require2.withField;

var TARGET_PK_FIELD = 'targetPk';
var ROOT_PK_FIELD = 'rootPk';

/*
 * Generate relation data
 */

var assignRelation = function assignRelation(name, _ref) {
  var model = _ref.model,
      _ref$relatedName = _ref.relatedName,
      relatedName = _ref$relatedName === undefined ? null : _ref$relatedName,
      _ref$hasMany = _ref.hasMany,
      hasMany = _ref$hasMany === undefined ? false : _ref$hasMany;
  return { model: model, hasMany: hasMany, relatedName: relatedName };
};

var parseRelation = function parseRelation(name) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return opts.model ? assignRelation(name, opts) : assignRelation(name, { model: opts });
};

/*
 * Association
 */

var withPkSetEntries = function withPkSetEntries(_ref2) {
  var Base = _ref2.Base,
      pkSet = _ref2.pkSet,
      manager = _ref2.manager;
  return function (_Base) {
    (0, _inherits3.default)(_class, _Base);

    function _class() {
      (0, _classCallCheck3.default)(this, _class);
      return (0, _possibleConstructorReturn3.default)(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));
    }

    (0, _createClass3.default)(_class, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, entry;

        return _regenerator2.default.wrap(function entries$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 3;
                _iterator = pkSet.entries()[Symbol.iterator]();

              case 5:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context.next = 12;
                  break;
                }

                _step$value = (0, _slicedToArray3.default)(_step.value, 2), entry = _step$value[1];
                _context.next = 9;
                return manager.build(entry);

              case 9:
                _iteratorNormalCompletion = true;
                _context.next = 5;
                break;

              case 12:
                _context.next = 18;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context['catch'](3);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 18:
                _context.prev = 18;
                _context.prev = 19;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 21:
                _context.prev = 21;

                if (!_didIteratorError) {
                  _context.next = 24;
                  break;
                }

                throw _iteratorError;

              case 24:
                return _context.finish(21);

              case 25:
                return _context.finish(18);

              case 26:
              case 'end':
                return _context.stop();
            }
          }
        }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
      })
    }]);
    return _class;
  }(Base);
};

var withAssociationIndex = function withAssociationIndex(pk1, pk2) {
  return createObjectManagerMixin(function (_ref3) {
    var Base = _ref3.Base;
    return function (_Base2) {
      (0, _inherits3.default)(_class2, _Base2);

      function _class2(opts) {
        (0, _classCallCheck3.default)(this, _class2);

        var _this2 = (0, _possibleConstructorReturn3.default)(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).call(this, opts));

        _this2.indexes = _this2.getIndexes(opts);
        return _this2;
      }

      (0, _createClass3.default)(_class2, [{
        key: 'getIndexes',
        value: function getIndexes(_ref4) {
          var _ref5;

          var _ref4$indexes = _ref4.indexes,
              indexes = _ref4$indexes === undefined ? (_ref5 = {}, (0, _defineProperty3.default)(_ref5, pk1, {}), (0, _defineProperty3.default)(_ref5, pk2, {}), _ref5) : _ref4$indexes;

          return indexes;
        }
      }, {
        key: 'unlink',
        value: function unlink(values) {
          var pk1Value = values.get(pk1);
          var pk2Value = values.get(pk2);

          if (pk1Value in this.indexes[pk1]) this.indexes[pk1][pk1Value].delete(values);
          if (pk2Value in this.indexes[pk2]) this.indexes[pk2][pk2Value].delete(values);
        }
      }, {
        key: 'link',
        value: function link(values) {
          var pk1Value = values.get(pk1);
          var pk2Value = values.get(pk2);

          if (!(pk1Value in this.indexes[pk1])) this.indexes[pk1][pk1Value] = new Set();
          if (!(pk2Value in this.indexes[pk2])) this.indexes[pk2][pk2Value] = new Set();

          if (pk1Value && pk2Value) {
            this.indexes[pk1][pk1Value].add(values);
            this.indexes[pk2][pk2Value].add(values);
          }
        }
      }, {
        key: 'unsync',
        value: function unsync(values) {
          this.unlink(values);
          return (0, _get3.default)(_class2.prototype.__proto__ || Object.getPrototypeOf(_class2.prototype), 'unsync', this).call(this, values);
        }
      }, {
        key: 'sync',
        value: function sync(values) {
          this.unlink(values);

          var newValues = (0, _get3.default)(_class2.prototype.__proto__ || Object.getPrototypeOf(_class2.prototype), 'sync', this).call(this, values);

          this.link(newValues);
          return newValues;
        }
      }, {
        key: 'filterPkSet',
        value: function filterPkSet() {
          var expression = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
          var pk = arguments[1];

          var pkValue = expression[pk];

          return pkValue ? this.indexes[pk][pkValue] : null;
        }
      }, {
        key: 'filter',
        value: function filter(expression) {
          var pk1Set = this.filterPkSet(expression, pk1);
          var pk2Set = this.filterPkSet(expression, pk2);
          var pkSet = pk1Set && (!pk2Set || pk2Set.size > pk1Set.size) ? pk1Set : pk2Set;

          return pkSet ? this.clone({
            QuerySetConstructor: withPkSetEntries({
              pkSet: pkSet,
              Base: this.QuerySetConstructor,
              manager: this
            })
          }).filter(expression) : (0, _get3.default)(_class2.prototype.__proto__ || Object.getPrototypeOf(_class2.prototype), 'filter', this).call(this, expression);
        }
      }]);
      return _class2;
    }(Base);
  });
};

var createAssociation = function createAssociation(_ref6) {
  var root = _ref6.root,
      target = _ref6.target;
  return {
    src: {
      model: root,
      pkField: ROOT_PK_FIELD
    },
    dest: {
      model: target,
      pkField: TARGET_PK_FIELD
    },
    model: createModel([withField(ROOT_PK_FIELD), withField(TARGET_PK_FIELD), withAssociationIndex(ROOT_PK_FIELD, TARGET_PK_FIELD)])
  };
};

var reverseAssociation = function reverseAssociation(_ref7) {
  var src = _ref7.src,
      dest = _ref7.dest,
      model = _ref7.model;
  return { src: dest, dest: src, model: model };
};

/*
 * Many relation
 */

var createManyQuerysetConstructor = function createManyQuerysetConstructor(QuerySetConstructor) {
  return function (_QuerySetConstructor) {
    (0, _inherits3.default)(_class3, _QuerySetConstructor);

    function _class3(_ref8) {
      var association = _ref8.association,
          entry = _ref8.entry;
      (0, _classCallCheck3.default)(this, _class3);

      var _this3 = (0, _possibleConstructorReturn3.default)(this, (_class3.__proto__ || Object.getPrototypeOf(_class3)).call(this, { parent: association.model.objects.filter((0, _defineProperty3.default)({}, association.src.pkField, entry.pk)) }));

      _this3.association = association;
      _this3.originEntry = entry;
      return _this3;
    }

    (0, _createClass3.default)(_class3, [{
      key: 'entries',
      value: _regenerator2.default.mark(function entries() {
        var _iteratorNormalCompletion2, _didIteratorError2, _iteratorError2, _iterator2, _step2, entry;

        return _regenerator2.default.wrap(function entries$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _iteratorNormalCompletion2 = true;
                _didIteratorError2 = false;
                _iteratorError2 = undefined;
                _context2.prev = 3;
                _iterator2 = (0, _get3.default)(_class3.prototype.__proto__ || Object.getPrototypeOf(_class3.prototype), 'entries', this).call(this)[Symbol.iterator]();

              case 5:
                if (_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done) {
                  _context2.next = 12;
                  break;
                }

                entry = _step2.value;
                _context2.next = 9;
                return this.association.dest.model.objects.get(entry[this.association.dest.pkField]);

              case 9:
                _iteratorNormalCompletion2 = true;
                _context2.next = 5;
                break;

              case 12:
                _context2.next = 18;
                break;

              case 14:
                _context2.prev = 14;
                _context2.t0 = _context2['catch'](3);
                _didIteratorError2 = true;
                _iteratorError2 = _context2.t0;

              case 18:
                _context2.prev = 18;
                _context2.prev = 19;

                if (!_iteratorNormalCompletion2 && _iterator2.return) {
                  _iterator2.return();
                }

              case 21:
                _context2.prev = 21;

                if (!_didIteratorError2) {
                  _context2.next = 24;
                  break;
                }

                throw _iteratorError2;

              case 24:
                return _context2.finish(21);

              case 25:
                return _context2.finish(18);

              case 26:
              case 'end':
                return _context2.stop();
            }
          }
        }, entries, this, [[3, 14, 18, 26], [19,, 21, 25]]);
      })
    }, {
      key: 'add',
      value: function add(entry) {
        var _association$model$ob2;

        this.association.model.objects.createTransaction();

        this.association.model.objects.getOrCreate((_association$model$ob2 = {}, (0, _defineProperty3.default)(_association$model$ob2, this.association.src.pkField, this.originEntry.pk), (0, _defineProperty3.default)(_association$model$ob2, this.association.dest.pkField, entry.pk), _association$model$ob2));

        this.association.model.objects.commitTransaction();
      }
    }, {
      key: 'remove',
      value: function remove(entry) {
        var _association$model$ob3;

        this.association.model.objects.createTransaction();

        var associatedEntry = this.association.model.objects.get((_association$model$ob3 = {}, (0, _defineProperty3.default)(_association$model$ob3, this.association.src.pkField, this.originEntry.pk), (0, _defineProperty3.default)(_association$model$ob3, this.association.dest.pkField, entry.pk), _association$model$ob3));

        if (associatedEntry) associatedEntry.delete();

        this.association.model.objects.commitTransaction();
      }
    }]);
    return _class3;
  }(QuerySetConstructor);
};

var createWithManyAccessor = function createWithManyAccessor(_ref9) {
  var fieldName = _ref9.fieldName,
      association = _ref9.association,
      setup = _ref9.setup;

  var QuerySetConstructor = createManyQuerysetConstructor(setup.get('QuerySetConstructor'));

  return createEntryMixin(function (_ref10) {
    var Base = _ref10.Base;
    return function (_Base3) {
      (0, _inherits3.default)(_class4, _Base3);

      function _class4() {
        (0, _classCallCheck3.default)(this, _class4);
        return (0, _possibleConstructorReturn3.default)(this, (_class4.__proto__ || Object.getPrototypeOf(_class4)).apply(this, arguments));
      }

      (0, _createClass3.default)(_class4, [{
        key: fieldName,
        get: function get() {
          return new QuerySetConstructor({ association: association, entry: this });
        }
      }]);
      return _class4;
    }(Base);
  });
};

/*
 * One relation
 */

var createWithOneAccessor = function createWithOneAccessor(_ref11) {
  var fieldName = _ref11.fieldName,
      association = _ref11.association;
  return createEntryMixin(function (_ref12) {
    var Base = _ref12.Base;
    return function (_Base4) {
      (0, _inherits3.default)(_class5, _Base4);

      function _class5() {
        (0, _classCallCheck3.default)(this, _class5);
        return (0, _possibleConstructorReturn3.default)(this, (_class5.__proto__ || Object.getPrototypeOf(_class5)).apply(this, arguments));
      }

      (0, _createClass3.default)(_class5, [{
        key: fieldName,
        get: function get() {
          var associatedEntry = association.model.objects.get((0, _defineProperty3.default)({}, association.src.pkField, this.pk));

          return associatedEntry ? association.dest.model.objects.get(associatedEntry[association.dest.pkField]) : null;
        },
        set: function set(entry) {
          association.model.objects.createTransaction();

          association.model.objects.getOrCreate((0, _defineProperty3.default)({}, association.src.pkField, this.pk)).update((0, _defineProperty3.default)({}, association.dest.pkField, entry.pk));

          association.model.objects.commitTransaction();
        }
      }]);
      return _class5;
    }(Base);
  });
};

/*
 * API
 */

var createRelationComposer = function createRelationComposer(name) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var rootAccessor = arguments[2];
  return function (_ref13) {
    var model = _ref13.model,
        setup = _ref13.setup;

    var relation = parseRelation(name, opts);
    var association = createAssociation({ root: model, target: relation.model });
    var relationOpts = {
      setup: setup,
      fieldName: relation.relatedName,
      association: reverseAssociation(association)
    };

    if (relation.relatedName && !relation.hasMany) {
      relation.model.inject(createWithOneAccessor(relationOpts));
    } else if (relation.relatedName && relation.hasMany) {
      relation.model.inject(createWithManyAccessor(relationOpts));
    }

    return rootAccessor({ association: association, setup: setup, fieldName: name })({ model: model, setup: setup });
  };
};

var withMany = function withMany(name) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return createRelationComposer(name, opts, createWithManyAccessor);
};
var withOne = function withOne(name) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return createRelationComposer(name, opts, createWithOneAccessor);
};

module.exports = {
  withOne: withOne,
  withMany: withMany
};
